Program Body3D;
{$N+}

{ 3D Objects & ZBuffer

Copyright (C) 1997-98 TothPaul@mygale.org
 http://www.mygale.org/~tothpaul

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

uses
 object3D,Tweak;

function keypressed:boolean; assembler;
 asm
  mov es,Seg0040
  mov ax,es:[$1A]
  sub ax,es:[$1C]
  or  al,ah
 end;

Const
 fac=2;
Var
 Pal:array[0..255,0..2] of byte;
 i:word;

 Torus   :^TTorus;
 Cube    :^TCube;
 Cylinder:^TCylinder;
 Sphere  :^TGSphere;

 Body    :^TCylinder;

 Cyl2    :^TCylinder;
 Cyl3    :^TCylinder;

 Eyes    :^TSphere;

 PhiX,PhiY,PhiZ:word;

begin
 WriteLn(#254' 3DWorld by Paul TOTH <tothpaul@mygale.org>');

 Write(#16' Create Torus');
 New(Torus,Create(8,6,100,20));
 Torus^.ComputeNormals(64);
 Writeln;

 New(Cyl3,Create(8,150,110,85));
 Cyl3^.ComputeNormals(32);


 Write(#16' Create Cube');
 New(Cube,Create(150,150,100));
 Cube^.ComputeNormals(64);
 Writeln;

 Write(#16' Create Cylinder');
 New(Cylinder,Create(6,100,40,10));
 Cylinder^.ComputeNormals(64);
 Writeln;

 Write(#16' Create Sphere');
 New(Sphere,Create(10,100));
 Sphere^.ComputeNormals(64);
 Writeln;

 New(Body,Create(6,50,50,50));
 Body^.ComputeNormals(64);

 New(Cyl2,Create(6,40,40,15));
 Cyl2^.ComputeNormals(64);

 New(Eyes,Create(6,20));
 Eyes^.ComputeNormals(10);

 GraphMode;
 for i:=1 to 64 Do begin
  pal[i,0]:=i div fac;
  pal[i,1]:=10+Round(i/fac/1.4);
  pal[i,2]:=20+Round(i/fac/1.6);
 end;
 for i:=1 to 64 Do begin
  pal[63+i,0]:=i div fac;
  pal[63+i,2]:=10+Round(i/fac/1.4);
  pal[63+i,1]:=20+Round(i/fac/1.6);
 end;
 for i:=1 to 64 Do begin
  pal[127+i,2]:=i div fac;
  pal[127+i,1]:=10+Round(i/fac/1.4);
  pal[127+i,0]:=20+Round(i/fac/1.6);
 end;
 SetPalette(@Pal);

 with Light do begin x:=33; y:=-10; z:=-10; end; { % }

 phix:=74;
 phiy:=32;
 phiz:=0;

 repeat

  Port[$3c4]:=2;
  Port[$3c5]:=15;
 { for i:=0 to MaxY do FillChar(Mem[$A000:Page+NextLine*i],NextLine,i); }
  asm
   mov es,SegA000
   mov di,Page
   mov dx,MaxY
   mov ax,63
  @nextline:
   mov cx,NextLine
   rep stosb
   add ah,63
   jnc @notnow
    dec al
   @notnow:
   dec dx
  jns @nextline
  end;

  InitZBuffers;

  Torus^.Translate(0,0,-55);
  Torus^.Rotate(phix+5,phiy,phiz);
  Torus^.Project;
  Torus^.DrawGouraud(32);

  Cyl3^.Translate(0,0,-100);
  Cyl3^.Rotate(phix+5,phiy,phiz);
  Cyl3^.Project;
  Cyl3^.DrawGouraud(32-2);

  Cube^.Translate(0,0,+170);
  Cube^.Rotate(phix-10,phiy,phiz);
  Cube^.Project;
  Cube^.Draw(64+32);

  Cylinder^.Translate(0,10,100);
  Cylinder^.Rotate(phix+64,phiy,phiz);
  Cylinder^.Project;
  Cylinder^.DrawGouraud(128+32);

  Body^.Translate(0,0,115);
  Body^.Rotate(phix-15,phiy,phiz);
  Body^.Project;
  Body^.DrawGouraud(128+32);

  Sphere^.Translate(0,0,0);
  Sphere^.Rotate(phix,phiy,phiz);
  Sphere^.Project;
  Sphere^.DrawGouraud(128+32);

  Cyl2^.Translate(0,10,110);
  Cyl2^.Rotate(phix+30,phiy,phiz);
  Cyl2^.Project;
  Cyl2^.DrawGouraud(128+32);

  Eyes^.Translate(0,10,85);
  Eyes^.Rotate(phix+75,phiy+20,phiz);
  Eyes^.Project;
  Eyes^.DrawGouraud(54);

  Eyes^.Translate(0,10,85);
  Eyes^.Rotate(phix+75,phiy+255-20,phiz);
  Eyes^.Project;
  Eyes^.DrawGouraud(54);


  Swap;

  inc(phix,0);
  inc(phiy,2);
  inc(phiz,0);

 until keypressed;

 Dispose(Torus,Destroy);
 Dispose(Cube,Destroy);

 Dispose(Cylinder,Destroy);

 Dispose(Sphere,Destroy);

 TextMode;
end.